/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Arbres
// (pour les arbres binaires, voir bintree.h)

// la structure est ici volontairement exportée

// Un arbre n'est jamais vide ; sa racine contient un pointeur `children`
// vers la forêt de ses sous-arbres.
// Une forêt est une liste chaînée d'arbres (pointeur `next`). La forêt vide
// est représentée par NULL.

#include "prelude.h"

#ifndef TREE
#define TREE

typedef struct Tree {
  int value;
  struct Tree *children; // premier sous-arbre
  struct Tree *next;  // suivant dans la forêt
} tree;

tree *tree_create(int v);
void tree_add_first_child(tree *t, tree *c);
  // ajoute c comme premier sous-arbre de t
void tree_add_last_child(tree *t, tree *c);
  // ajoute c comme dernier sous-arbre de t
int tree_size(tree *t);
void tree_preorder(tree *t);

void tree_delete(tree *t);
  // attention : suppose qu'il n'y a pas de partage de sous-arbre

#endif
